//---------------------------------------------------------------------------
// Klasse     : LCD_Text
// Datei      : LCD_Text.h
// Datum      : 11.06.2007
// Version    : 1.0
// Autor      : Karsten Donat
//---------------------------------------------------------------------------

#ifndef _LCD_TEXT_H_
#define _LCD_TEXT_H_

#include <avr/io.h>


// Typ
#define LCD_TYP HD44780U_8Bit

// Character Set
#define LCD_Charset A00_Japan
//#define LCD_Charset A02_Europe

// Display Resolution
#define LCD_Width 40
#define LCD_Height 2


// Anschlussbelegung Steuerleitungen
#define LCD_RS_DDR  DDRD
#define LCD_RS_PORT PORTD
#define LCD_RS_PIN  PIN5
#define LCD_RW_DDR  DDRD
#define LCD_RW_PORT PORTD
#define LCD_RW_PIN  PIN6
#define LCD_E_DDR   DDRD
#define LCD_E_PORT  PORTD
#define LCD_E_PIN   PIN7
// Anschlussbelegung Datenleitungen
#define LCD_D0_DDR  DDRC
#define LCD_D0_PORT PORTC
#define LCD_D0_PIN  PIN5
#define LCD_D1_DDR  DDRC
#define LCD_D1_PORT PORTC
#define LCD_D1_PIN  PIN4
#define LCD_D2_DDR  DDRC
#define LCD_D2_PORT PORTC
#define LCD_D2_PIN  PIN3
#define LCD_D3_DDR  DDRC
#define LCD_D3_PORT PORTC
#define LCD_D3_PIN  PIN2
#define LCD_D4_DDR  DDRC
#define LCD_D4_PORT PORTC
#define LCD_D4_PIN  PIN1
#define LCD_D5_DDR  DDRC
#define LCD_D5_PORT PORTC
#define LCD_D5_PIN  PIN0
#define LCD_D6_DDR  DDRB
#define LCD_D6_PORT PORTB
#define LCD_D6_PIN  PIN0
#define LCD_D7_DDR  DDRB
#define LCD_D7_PORT PORTB
#define LCD_D7_PIN  PIN1

int LCD_Text_Create();
int LCD_Text_Destroy();

void LCD_Clear_display();
void LCD_Write_String(char* pText);
void LCD_Return_home();
#define _INCREMENT_ 0b10
#define _DECREMENT_ 0b00
#define _LEFT_TO_RIGHT_ 0b0
#define _RIGHT_TO_LEFT_ 0b1
void LCD_Entry_mode_set(unsigned char IncDec,unsigned char Direction);
void LCD_Display_Off();
void LCD_Display_On_Cursor_Off();
void LCD_Display_On_Cursor_On();
void LCD_Display_On_Cursor_Blinking();
void LCD_Display_On_Cursor_Blinking_Both();
void LCD_GotoXY(int x, int y);

// Hintergrundfunktionen
void LCD_Write_Command         (unsigned char Command, double Pause);
unsigned char LCD_Read_Command (unsigned char Command, double Pause);
void LCD_Write_Char            (unsigned char Daten, double Pause);
unsigned char LCD_Read_Char    (unsigned char Command, double Pause);

// Teilfunktionen
void LCD_Select_InstructionRegister();
void LCD_Select_DataRegister();
void LCD_Select_Read();
void LCD_Select_Write();
void LCD_Start_Transfer();
void LCD_Stop_Transfer();
void LCD_Set_Byte(unsigned char Daten);   // schreibt das Daten-Byte in die entsprechenden Register
unsigned char LCD_Get_Byte();


#endif

