//---------------------------------------------------------------------------
// Klasse     : Standard
// Datei      : Standard.h
// Datum      : 11.06.2007
// Version    : 1.0
// Autor      : Karsten Donat
//---------------------------------------------------------------------------

#ifndef _STANDARD_H_
#define _STANDARD_H_

// Bitoperationen
//#define setBit  (Ziel,Bit) (Ziel |=  Bit)
//#define clearBit(Ziel,Bit) (Ziel &= ~Bit)

/* Define bit macros, note that they are similar to the I/O macros*/
#define SetBit(x,y)   (x |= (1<<y))     /* Set   bit y in byte x */
#define ClearBit(x,y) (x &= (~(1<<y)))  /* Clear bit y in byte x */
#define CheckBit(x,y) ((x & (1<<y))>>y) /* Check bit y in byte x */ 
//#define CheckBit(x,y) (x & (1<<y))     /* Check bit y in byte x */ 

// Datentypen
#define uchar unsigned char
#define uint unsigned int

/*
typedef signed char        int8_t;
typedef unsigned char      uint8_t;
 
typedef short              int16_t;
typedef unsigned short     uint16_t;
 
typedef long               int32_t;
typedef unsigned long      uint32_t;
 
typedef long long          int64_t;
typedef unsigned long long uint64_t;
*/

// Datentypen quivalent zu Delphi
typedef          char       Shortint;   //        -128..127          8 Bit, mit  Vorzeichen
typedef          short      Smallint;   //      -32768..32767       16 Bit, mit  Vorzeichen
typedef          long       Integer;    // -2147483648..2147483647  32 Bit, mit  Vorzeichen
typedef          long long  Int64;      //       -2^63..2^63-1      64 Bit, mit  Vorzeichen
typedef unsigned char       Byte;       //           0..255          8 Bit, ohne Vorzeichen
typedef unsigned short      Word;       //           0..65535       16 Bit, ohne Vorzeichen
typedef unsigned long       DWord;      //           0..4294967295  32 Bit, ohne Vorzeichen
typedef unsigned long long  QWord;      //           0..2^64-1      64 Bit, ohne Vorzeichen

typedef unsigned char       Boolean;
//#define Boolean unsigned char
//#define Byte unsigned char
//#define Word unsigned int


int Standard_Create();
int Standard_Destroy();

void delay_ms_grob(double ms);
void IntToStr( int z, char* Buffer );
void DWordToStr( DWord z, char* Buffer );

#endif

