//---------------------------------------------------------------------------
// Klasse     : Uhr
// Datei      : Uhr.cpp
// Datum      : 18.06.2007
// Version    : 1.0
// Autor      : Karsten Donat
//---------------------------------------------------------------------------

#include "Uhr.h"

SIGNAL (SIG_OUTPUT_COMPARE1A)
{
   Ticks++; // berschlag bei 4ms Intervall alle 198 Tage

   #if XTAL % DEBOUNCE                     // bei rest
      OCR1A = XTAL / DEBOUNCE - 1;		// compare DEBOUNCE - 1 times
   #endif

   if( --prescaler == 0 )
   {
      prescaler = (uchar)DEBOUNCE;

         // Zeit Updaten
         if (++Sekunde>59)
         {
            Sekunde=0;
            if (++Minute>59)
            {
               Minute=0;
               if (++Stunde>23)
               {
                  Stunde=0;
                  ++Tag;
                  Update_Datum=true;

               /* Tag	Monat				Jahr
                  32	01, 03, 05, 07, 08, 10, 12
                  31	04, 06, 09, 11
                  30	02
                  29	02				(Jahr % 4)>0 */
                  if  ( ((Tag>=32)                                                       ) // 31 Tage-Monate
                      or((Tag==31)and((Monat==04)or(Monat==06)or(Monat== 9)or(Monat==11))) // 30 Tage-Monate
                      or((Tag==30)and (Monat==02)                                        ) // Februar Schaltjahr
                      or((Tag==29)and (Monat==02)and((Jahr%4)>0)                         ))// Februar normal
                  {
                     Tag=01;
                     if (++Monat>12)
                     {
                        Monat=01;
                        ++Jahr;
                     }
                  }
               }
            }
         }
      Update_Zeit=true;

      #if XTAL % DEBOUNCE			// handle remainder
         OCR1A = XTAL / DEBOUNCE + XTAL % DEBOUNCE - 1; // compare once per second
      #endif
   }
}


void Uhr_SetDateTime(Byte nTag, Byte nMonat, Word nJahr, Byte nStunde, Byte nMinute, Byte nSekunde)
{
   Tag    = nTag;
   Monat  = nMonat;
   Jahr   = nJahr;
   Stunde = nStunde;
   Minute = nMinute;
   Sekunde= nSekunde;
}


int Uhr_Create(Boolean Enable_Interupt)
{
   // ToDo: Initialisierungsroutine
   Uhr_SetDateTime(01,01,2007,00,00,00);
   Ticks  = 0;
   //Tag    = 01;
   //Monat  = 01;
   //Jahr   = 2007;
   //Stunde = 00;
   //Minute = 00;
   //Sekunde= 00;

   Update_Zeit  = true;
   Update_Datum = true;


   // Test-Flle
   //Uhr_SetDateTime(27,01,2007,23,59,55);
   //Uhr_SetDateTime(28,01,2007,23,59,55);
   //Uhr_SetDateTime(29,01,2007,23,59,55);
   //Uhr_SetDateTime(30,01,2007,23,59,55);
   //Uhr_SetDateTime(31,01,2007,23,59,55);
   //Uhr_SetDateTime(27,01,2008,23,59,55);
   //Uhr_SetDateTime(28,01,2008,23,59,55);
   //Uhr_SetDateTime(29,01,2008,23,59,55);
   //Uhr_SetDateTime(30,01,2008,23,59,55);
   //Uhr_SetDateTime(31,01,2008,23,59,55);
   //Uhr_SetDateTime(27,02,2007,23,59,55);
   //Uhr_SetDateTime(28,02,2007,23,59,55);
   //Uhr_SetDateTime(27,02,2008,23,59,55);
   //Uhr_SetDateTime(28,02,2008,23,59,55);
   //Uhr_SetDateTime(29,02,2008,23,59,55);
   //Uhr_SetDateTime(30,03,2007,23,59,55);
   //Uhr_SetDateTime(31,03,2007,23,59,55);
   //Uhr_SetDateTime(29,04,2007,23,59,55);
   //Uhr_SetDateTime(30,04,2007,23,59,55);
   //Uhr_SetDateTime(30,05,2007,23,59,55);
   //Uhr_SetDateTime(31,05,2007,23,59,55);
   //Uhr_SetDateTime(29,06,2007,23,59,55);
   //Uhr_SetDateTime(30,06,2007,23,59,55);
   //Uhr_SetDateTime(30,07,2007,23,59,55);
   //Uhr_SetDateTime(31,07,2007,23,59,55);
   //Uhr_SetDateTime(30,08,2007,23,59,55);
   //Uhr_SetDateTime(31,08,2007,23,59,55);
   //Uhr_SetDateTime(29,09,2007,23,59,55);
   //Uhr_SetDateTime(30,09,2007,23,59,55);
   //Uhr_SetDateTime(30,10,2007,23,59,55);
   //Uhr_SetDateTime(31,10,2007,23,59,55);
   //Uhr_SetDateTime(29,11,2007,23,59,55);
   //Uhr_SetDateTime(30,11,2007,23,59,55);
   //Uhr_SetDateTime(30,12,2007,23,59,55);
   //Uhr_SetDateTime(31,12,2007,23,59,55);

   TCCR1B = 1<<WGM12^1<<CS10;		// divide by 1
					// clear on compare
   OCR1A = F_CPU / DEBOUNCE - 1;          // Output Compare Register
   TCNT1 = 0;                            // Timmer startet mit 0
   prescaler = (uchar)DEBOUNCE;          //software teiler
   TIMSK1 = 1<<OCIE1A;                    // beim Vergleichswertes Compare Match                    
                                        // Interrupt (SIG_OUTPUT_COMPARE1A)
   if (Enable_Interupt==true)
   {
      sei();
   }

   return 0;
}

int Uhr_Destroy()
{
   // ToDo: Aufrumen
   return 0;
}



/*char* TimeToString()
{
//   return ":"+":";
   return "0";
}

char* DateTimeToString()
{
   return "0";
}*/

void ItoA_Zeit( int z, char* Buffer )
{
  int i = 0;
  int j;
  char tmp;
 
  // 0 braucht eine Sonderbehandlung
  if( z == 0 ) {
      Buffer[0] = '0';
      Buffer[1] = '0';
      Buffer[2] = '\0';
  }
  else {
 
      j=z;// Zahl zwischenspeichern fr <10 

    // die einzelnen Stellen der Zahl berechnen
    while( z > 0 ) {
      Buffer[i++] = '0' + z % 10;
      z /= 10;
    }
 
    // ist die Zahl negativ?
    // gleich mal ein - hinterlassen und die Zahl positiv machen
    if( j < 10 ) {
      Buffer[i++] = '0';
    }

    // den String in sich spiegeln
    for( j = 0; j < i / 2; ++j ) {
      tmp = Buffer[j];
      Buffer[j] = Buffer[i-j-1];
      Buffer[i-j-1] = tmp;
    }
 
    Buffer[i] = '\0';
  }
}
