//---------------------------------------------------------------------------
// Klasse     : Uhr
// Datei      : Uhr.h
// Datum      : 18.06.2007
// Version    : 1.0
// Autor      : Karsten Donat
//---------------------------------------------------------------------------

#ifndef _UHR_H_
#define _UHR_H_

#include <avr/interrupt.h>
#include "Standard.h"

//#define _mit_export_

#ifndef  _mit_export_
   #define DEBOUNCE	256L		// debounce clock (256Hz = 4msec)
   uchar prescaler;

   volatile Byte Tag;
   volatile Byte Monat;
   volatile Word Jahr;
   volatile Byte Stunde;
   volatile Byte Minute;
   volatile Byte Sekunde;
   volatile DWord Ticks;
   volatile Byte Update_Zeit;
   volatile Byte Update_Datum;
#elif defined _mit_export_
   #define DEBOUNCE	256L		// debounce clock (256Hz = 4msec)
   extern uchar prescaler;

   extern volatile Byte Tag;
   extern volatile Byte Monat;
   extern volatile Word Jahr;
   extern volatile Byte Stunde;
   extern volatile Byte Minute;
   extern volatile Byte Sekunde;
   extern volatile DWord Ticks;
   extern volatile Boolean Update_Zeit;
   extern volatile Boolean Update_Datum;
#endif


int Uhr_Create(Boolean Enable_Interupt=true);
int Uhr_Destroy();

void Uhr_SetDateTime(Byte nTag, Byte nMonat, Word nJahr, Byte nStunde, Byte nMinute, Byte nSekunde);

//char* TimeToString();
//char* DateTimeToString();

SIGNAL (SIG_OUTPUT_COMPARE1A);

void ItoA_Zeit( int z, char* Buffer );

#endif
